// VSTp̃CN[ht@C
#include "myvst3define.h"
#include "myvst3fuid.h"
#include "processor.h"


// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {


// ===================================================================================
// RXgN^
// ===================================================================================
MyVSTProcessor::MyVSTProcessor()
{
	// Rg[[FUIDݒ肷
	setControllerClass(ControllerUID);
}

// ===================================================================================
// NX֐
// ===================================================================================
tresult PLUGIN_API MyVSTProcessor::initialize(FUnknown* context)
{
	// ܂pNX̏{
	tresult result = AudioEffect::initialize(context);
	if (result == kResultTrue)
	{
		// ͂Əo͂ݒ
		addAudioInput(STR16("AudioInput"), SpeakerArr::kStereo);
		addAudioOutput(STR16("AudioOutput"), SpeakerArr::kStereo);

		// ͂EventBusǉ
		addEventInput(STR16("Event Input"), 1);

		// ȉŗL̏{B

		volume = 1.0f;
	}


	// kResultTrueԂB
	return result;
}

tresult PLUGIN_API MyVSTProcessor::setBusArrangements(SpeakerArrangement* inputs, int32 numIns, SpeakerArrangement* outputs, int32 numOuts)
{
	// inputoutput̃oX1ŁAinputoutput̍\XeȈꍇ
	if (numIns == 1 && numOuts == 1 && inputs[0] == SpeakerArr::kStereo && outputs[0] == SpeakerArr::kStereo)
	{
		return AudioEffect::setBusArrangements(inputs, numIns, outputs, numOuts);
	}

	// ΉĂȂoX\̏ꍇAkResultFalseԂB
	return kResultFalse;
}

// ===================================================================================
// M֐
// ===================================================================================
tresult PLUGIN_API MyVSTProcessor::process(ProcessData& data)
{
	// p[^[ύX̏
	// ^ꂽp[^[ƂAdatainputParameterChanges
	// IParameterChangesNXւ̃|C^̃AhX
	if (data.inputParameterChanges != NULL)
	{
		// ^ꂽp[^[̐擾
		int32 paramChangeCount = data.inputParameterChanges->getParameterCount();

		// ^ꂽp[^[AJԂB
		for (int32 i = 0; i < paramChangeCount; i++)
		{
			// p[^[ύX̃L[擾
			// (Tvɕ̃p[^[ύX񂪂\邽߁A
			// L[Ƃ`ɂȂĂB)
			IParamValueQueue* queue = data.inputParameterChanges->getParameterData(i);
			if (queue != NULL)
			{
				// ǂ̃p[^[ύXꂽm邽߁Ap[^[tag擾
				int32 tag = queue->getParameterId();

				// ύXꂽ񐔂擾
				int32 valueChangeCount = queue->getPointCount();
				ParamValue value;
				int32 sampleOffset;

				// ŌɕύXꂽl擾
				if (queue->getPoint(valueChangeCount - 1, sampleOffset, value) == kResultTrue)
				{
					// tagɉ{
					switch (tag)
					{
					case PARAM1_TAG:
						// volumeύXB
						volume = value;
						break;
					}
				}
			}
		}
	}

	// ́Eo̓obt@̃|C^킩₷ϐɊi[
	// inputs[]Aoutputs[]AudioBus̐(addAudioInput()AaddAudioOutput()Œǉ)
	// AudioBus1Ȃ̂ 0 ݂̂ƂȂ
	// channelBuffers3232bit_^̃obt@ŉM̃`l
	// m(kMono)Ȃ 0 ݂̂ŁAXeI(kStereo)Ȃ 0(Left)  1(Right) ƂȂ
	Sample32* inL = data.inputs[0].channelBuffers32[0];
	Sample32* inR = data.inputs[0].channelBuffers32[1];
	Sample32* outL = data.outputs[0].channelBuffers32[0];
	Sample32* outR = data.outputs[0].channelBuffers32[1];

	// numSamplesŎTvA
	for (int32 i = 0; i < data.numSamples; i++)
	{
		outL[i] = volume * inL[i];
		outR[i] = volume * inR[i];
	}

	// ȂkResultTrueԂ(炭KkResultTrueԂ)
	return kResultTrue;
}

}
} // namespace SteinbergVst̏I