#ifndef __PROCESSOR_H__
#define __PROCESSOR_H__

// VST3 SDK̃CN[ht@C
#include "public.sdk/source/vst/vstaudioeffect.h"
#include "pluginterfaces/vst/ivstparameterchanges.h"

// VSTp̃CN[ht@C
#include "myvst3def.h"


// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {

// ============================================================================================
// MProcessorNX
// ============================================================================================
class MyVSTProcessor : public AudioEffect
{
protected:
	ParamValue depth; // {[AgAp̂([)
	ParamValue freq;  // gAp̎({[͖)
	int32      type;  // GtFN^[̃^Cv({[AgAp3)

	ParamValue theta; // gŎgpSIN֐̊px
public:
	MyVSTProcessor();

	// NX֐(K{)
	tresult PLUGIN_API initialize(FUnknown* context);

	// oX\ݒ肷֐
	tresult PLUGIN_API setBusArrangements(SpeakerArrangement* inputs, int32 numIns, SpeakerArrangement* outputs, int32 numOuts);

	// M֐
	tresult PLUGIN_API process(ProcessData& data);

	// VST ProcessorNX̃CX^X쐬邽߂̊֐(K{)
	static FUnknown* createInstance(void*) { return (IAudioProcessor*)new MyVSTProcessor(); }
};


} } // namespace SteinbergVst̏I

#endif