#include "myparameter.h"

// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {

// RXgN^(po[ϐȂǂ̏s߂قڕK{)
MyParameter::MyParameter(const TChar *title, ParamID tag, const TChar *units, ParamValue minPlain,
	ParamValue maxPlain, ParamValue defaultValuePlain, int32 flags, UnitID unitID)
	: Parameter(title, tag, units, 0.0f, 0, flags, unitID) // ꕔ̈͌pNXɂ̂܂ܓnA
{
	// ŏlAőlݒ
	min = minPlain;
	max = maxPlain;

	// ftHglݒ
	// valueNormalized͌p(Parameter)NXŒ`ꂽKꂽ݂̒l
	// toNormalized()֐gĈ̃ftHgl(\l)𐳋K
	valueNormalized = toNormalized(defaultValuePlain);
}

// Kꂽl(0.0f`1.0f̒l)\l̕ɂ֐
void MyParameter::toString(ParamValue valueNormalized, String128 string) const
{
	// Kꂽl𕶎ɂɂUString128NXg
	// UString128NX͓ɕpobt@(128)NX
	// ڍׂ͊邪A낢ϊ邽߂̊֐pӂĂ
	UString128 wrapper;

	// printFloat()֐float̒l𕶎ɂAwrapper̓pobt@ɕۑ
	// KꂽlȂ̂ŁAtoPlain()֐g\lɕϊĂۑB
	// precision͏扽ʂ܂ŕ\邩ϐ(pNXŒ`ς)
	wrapper.printFloat(toPlain(valueNormalized), precision);

	// pobt@stringɃRs[
	wrapper.copyTo(string, 128);
}

// \Ă镶񂩂琳Kꂽl(0.0f`1.0f̒l)擾֐
bool MyParameter::fromString(const TChar* string, ParamValue& valueNormalized) const
{
	// \l̕񂩂琳Kl擾ɂɂUString128NXg
	// ܂Awrapper̓pobt@stringݒ肷
	UString wrapper((TChar*)string, strlen16(string));

	//  \l̕񂩂\l擾
	ParamValue plainvalue;
	if (wrapper.scanFloat(plainvalue))
	{
		// \l擾ɐAtoNormalized()֐ŐKAvalueNormalizedɑ
		valueNormalized = toNormalized(valueNormalized);

		// ϊɐtrueԂ
		return true;
	}

	// ϊɎsfalseԂ
	return false;
}

// Kꂽl(0.0f`1.0f̒l)\Ălɂ֐
ParamValue MyParameter::toPlain(ParamValue valueNormalized) const
{
	// Kl\lɕϊĕԂ
	// toNormalized()֐toPlain()֐ŉtł邱ƂKv
	// w֐ƂĂ͂Ƃ肠valueNormalized3悷֐ɂĂ(K)
	// 킹āAŏl`ől͈̔͂Ɏ߂悤vZB
	return ((max - min) * pow(valueNormalized, 3.0f)) + min;
}

// \Ăl琳Kꂽl(0.0f`1.0f̒l)ɂ֐
ParamValue MyParameter::toNormalized(ParamValue plainValue) const
{
	// \l𐳋KlɕϊĕԂ
	// toNormalized()֐toPlain()֐ŉtł邱ƂKv
	// toPlain()֐ł3悵Ă̂ŁAplainValue3捪vZ
	return pow((plainValue - min) / (max - min), 1.0f / 3.0f);
}

} } // namespace SteinbergVst̏I
