#ifndef __CMYPARAM_H__
#define __CMYPARAM_H__

// VST3 SDK̃CN[ht@C
#include "pluginterfaces/base/ftypes.h"
#include "pluginterfaces/base/ustring.h"
#include "public.sdk/source/vst/vsteditcontroller.h"

// VSTp̃CN[ht@C
#include <cmath>

// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {

// ============================================================================================
// wIȕω鎩p[^[NX
// ============================================================================================
class MyParameter : public Parameter
{
private:
	ParamValue min; // p[^[̕\l̍ŏ
	ParamValue max; // p[^[̕\l̍ő

public:
	// RXgN^(po[ϐȂǂ̏s߂قڕK{)
	MyParameter(const TChar *title, ParamID tag, const TChar *units = 0, ParamValue minPlain = 0.0,
		         ParamValue maxPlain = 1.0, ParamValue defaultValuePlain = 0.0,
				 int32 flags = ParameterInfo::kCanAutomate, UnitID unitID = kRootUnitId);

	// Kꂽl(0.0f`1.0f̒l)\l̕ɂ֐(K{)
	virtual void toString(ParamValue valueNormalized, String128 string) const;

	// \Ă镶񂩂琳Kꂽl(0.0f`1.0f̒l)擾֐(K{)
	virtual bool fromString(const TChar* string, ParamValue& valueNormalized) const;

	// Kꂽl(0.0f`1.0f̒l)\Ălɂ֐(K{)
	virtual ParamValue toPlain(ParamValue valueNormalized) const;

	// \Ăl琳Kꂽl(0.0f`1.0f̒l)ɂ֐(K{)
	virtual ParamValue toNormalized(ParamValue plainValue) const;

	// ParameterNX̊eݒp[^[NXu}N(K{)
	OBJ_METHODS(MyParameter, Parameter)

};

}} // namespace SteinbergVst̏I

#endif