#ifndef __PROCESSOR_H__
#define __PROCESSOR_H__

// VST3 SDK̃CN[ht@C
#include "public.sdk/source/vst/vstaudioeffect.h"
#include "pluginterfaces/vst/ivstparameterchanges.h"

// VSTp̃CN[ht@C
#include "myvst3def.h"
#include "CMyFilter.h"


// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {


// ============================================================================================
// MProcessorNX
// ============================================================================================
class MyVSTProcessor : public AudioEffect
{
protected:
	ParamValue freq;
	ParamValue q;
	CMyFilter filterL, filterR; // tB^NX ͏ȗ QlFhttp://vstcpp.wpblog.jp/?page_id=728

public:
	MyVSTProcessor();

	// NX֐(K{)
	tresult PLUGIN_API initialize(FUnknown* context);

	// 
	tresult PLUGIN_API setBusArrangements(SpeakerArrangement* inputs, int32 numIns, SpeakerArrangement* outputs, int32 numOuts);


	// M֐
	tresult PLUGIN_API process(ProcessData& data);

	// ֐
	tresult setParamater(int32 id, ParamValue value);
	tresult doProcessing(Sample32* inL, Sample32* inR, Sample32* outL, Sample32* outR, int32 numSamples);

	// VST ProcessorNX̃CX^X쐬邽߂̊֐(K{)
	static FUnknown* createInstance(void*) { return (IAudioProcessor*)new MyVSTProcessor(); }
};


} } // namespace SteinbergVst̏I

#endif