// VSTp̃CN[ht@C
#include "myvst3def.h"
#include "myvst3fuid.h"
#include "controller.h"


// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg{
namespace Vst {


// NX֐(K{)
tresult PLUGIN_API MyVSTController::initialize(FUnknown* context)
{
	// ܂pNX̏{
	tresult result = EditController::initialize(context);
	if (result == kResultTrue)
	{

		// ȉŗL̏{B

		// W̃p[^[Rg[[ɒǉ
		parameters.addParameter(STR16("Depth"), STR16("..."), 0, 1, ParameterInfo::kCanAutomate, PARAM_DEPTH_TAG);

		// ͈̓p[^[쐬
		RangeParameter* param1 = new RangeParameter(STR16("Speed"), PARAM_SPEED_TAG, STR16("Hz"), 0.5f, 30.0f, 5.0f);
		param1->setPrecision(2); // 扽ʂ܂ŕ\邩
		// ͈̓p[^[Rg[[ɒǉ
		parameters.addParameter(param1);

		// 񃊃Xgp[^[쐬Aǉ
		StringListParameter* param2 = new StringListParameter(STR16("Type"), PARAM_TYPE_TAG);
		param2->appendString(STR16("Volume"));  // Xgڂǉ
		param2->appendString(STR16("Tremolo"));
		param2->appendString(STR16("Panning"));
		// 񃊃Xgp[^[Rg[[ɒǉ
		parameters.addParameter(param2);
	}

	// kResultTrueԂB
	result = kResultTrue;
	return result;
}

// VST GUIEditor쐬֐
IPlugView* PLUGIN_API MyVSTController::createView(FIDString name)
{
	if (strcmp(name, ViewType::kEditor) == 0)
	{
		return new VSTGUI::VST3Editor(this, "view", "myEditor.uidesc");
	}
	return 0;
}
} } // namespace SteinbergVst̏I
