// VSTp̃CN[ht@C
#include "guieditor.h"


// VST3쐬ɕKvȂ̖OԂgp
namespace Steinberg {
namespace Vst {

// ============================================================================================
// RXgN^
// ============================================================================================
MyVSTGUIEditor::MyVSTGUIEditor(void* controller)
	: VSTGUIEditor(controller)
{
	// RXgN^ŃEBhETCYݒ肷
	// ݒ肵Ȃ΁AEBhEJȂ
	ViewRect viewRect(0, 0, 200, 200);
	setRect(viewRect);
}

// ============================================================================================
// GUIEBhEJƂAƂɌĂяo֐
// ============================================================================================
bool PLUGIN_API MyVSTGUIEditor::open(void* parent, const PlatformType& platformType)
{
	// GUIEBhEJꂽƂɁAUI쐬

	// ܂̓t[(zü)łɍ쐬Eݒ肳Ă邩mFB
	// łɍ쐬Eݒ肳Ăꍇ(frameNULLłȂꍇ)͏I
	// frame͌pNXŒ`ĂB
	if (frame) { return false; }

	// 쐬t[̃TCYݒ
	CRect size(0, 0, 200, 200);

	// t[쐬B쐬Ɏs(NULLȂ)IB
	// ɂ́At[TCYAGUINX̃|C^w肷
	frame = new CFrame(size, this);
	if (frame == NULL) { return false; }

	// 쐬t[ɔwi摜ݒ
	CBitmap* cbmp = new CBitmap("background.png"); // \[Xwi摜ǂݍ
	frame->setBackground(cbmp); // t[ɔwi摜ݒ
	cbmp->forget();	// t[ɐݒ͔wi摜forgetŉĂ

	// 쐬t[J
	frame->open(parent);


	//@---------------------------------------------
	// eRg[̍쐬
	createCombobox(PARAM_TYPE_TAG, 10, 10);
	createKnob(PARAM_SPEED_TAG, 20, 35);
	createSlider(PARAM_DEPTH_TAG, 20, 90);

	// GUIEBhẼI[vɐꍇtrueԂ
	return true;
}


// GUIEBhEƂɌĂяo֐
void PLUGIN_API MyVSTGUIEditor::close()
{
	// GUIEBhEƂɁAUI폜

	// t[
	// wi摜ǉ܂(mujXC_[Ȃǂ킹ĉ
	// (ʂŉKv͂Ȃ)
	if (frame)
	{
		frame->forget();
		frame = 0;
	}
}

// ============================================================================================
// GUIEBhẼRg[𑀍삵ƂɌĂяo֐
// ============================================================================================
void MyVSTGUIEditor::valueChanged(CControl* pControl)
{
	// ǂ̃p[^[삳ꂽ擾B
	int32 index = pControl->getTag();

	// p[^[̒l擾B
	float value = pControl->getValueNormalized();

	// 擾lp[^[ɔf
	controller->setParamNormalized(index, value);

	// NXɔflʒm
	controller->performEdit(index, value);
}

// ============================================================================================
// eRg[쐬鎩֐
// ============================================================================================
void MyVSTGUIEditor::createKnob(ParamID tag, int x, int y)
{
	// muRg[쐬

	// ܂͉摜t@Cǂݍ
	CBitmap *backbmp = new CBitmap("knob.png");
	CBitmap *handlebmp = new CBitmap("knob_handle.png");

	// muRg[̃TCY摜t@C擾
	CRect size(0, 0, backbmp->getWidth(), backbmp->getHeight());

	// muRg[̈ʒuw
	// ʒuݒ(frame̍オ0,0ƂȂ)
	size.offset(x, y);

	// muRg[̍쐬
	CKnob* control = new CKnob(size, this, tag, backbmp, handlebmp);

	// p[^݂̌̒l擾ARg[ɔf
	// controller͌pNXŒ`ĂA
	// GUIEditorNXĂяoRg[NXB
	ParamValue value = controller->getParamNormalized(tag);
	control->setValueNormalized(value);

	// muRg[t[ɓo^
	frame->addView(control);

	// ǂݍ񂾉摜͖Yꂸ
	backbmp->forget();
	handlebmp->forget();

}

// XC_[쐬郁o[֐
void MyVSTGUIEditor::createSlider(ParamID tag, int x, int y)
{
	// XC_[̍쐬
	// ܂͉摜t@Cǂݍ
	CBitmap *backbmp = new CBitmap("slider.png");
	CBitmap *handlebmp = new CBitmap("slider_handle.png");

	// 摜t@CTCY擾
	CRect  size;
	size(0, 0, backbmp->getWidth(), backbmp->getHeight());
	size.offset(x, y);   // ʒuݒ(tergetframe̍オ0,0ƂȂ)

	// XC_[̍쐬
	// XC_[nh̓XC_[wi摜̏ォ牺܂œȂ悤A
	// ኱̃}[WB̃}[W͉摜ɂĕς
	int bmpmargin = 1;
	CVerticalSlider* control = new CVerticalSlider(size, this, tag,
		y + bmpmargin,
		y + backbmp->getHeight() - (handlebmp->getHeight() + bmpmargin),
		handlebmp, backbmp);

	// p[^݂̌̒l擾ARg[ɔf
	ParamValue value = controller->getParamNormalized(tag);
	control->setValueNormalized(value);

	// XC_[t[ɓo^
	frame->addView(control);

	// ǂݍ񂾉摜͖Yꂸ
	backbmp->forget();
	handlebmp->forget();

}

// R{{bNX쐬郁o[֐
void MyVSTGUIEditor::createCombobox(ParamID tag, int x, int y)
{
	// R{{bNX̃TCYݒ(TCY͓K)
	CRect  size;
	size(0, 0, 60, 16);
	size.offset(x, y);

	// R{{bNX쐬
	COptionMenu* control = new COptionMenu(size, this, tag);

	// R{{bNXɑIǉ
	control->addEntry("Volume");
	control->addEntry("Tremolo");
	control->addEntry("Panning");


	// p[^݂̌̒l擾AR{{bNXf
	ParamValue value = controller->getParamNormalized(tag);
	control->setValueNormalized(value);

	// ^tHgw
	control->setFont(kNormalFontSmaller);

	// FEwiFݒ
	control->setFontColor(kWhiteCColor);
	control->setBackColor(kBlackCColor);
	control->setFrameColor(kRedCColor);

	// R{{bNXt[ɓo^
	frame->addView(control);

}

} } // namespace SteinbergVst̏I